unit MCGFX;

interface

  type
    IntArray = array of Integer;
    IntArrayPtr = ^IntArray;

  type
    TLayer =
      record
        TileSetID: string;
        TileW: Integer;
        TileH: Integer;
        MapW: Integer;
        MapH: Integer;
        TileMapData: IntArrayPtr;
        BoundMapData: IntArrayPtr;
      end;


  procedure MainCharMap1MapData;
  procedure MainCharMap1BoundMapData;

  const
    MainCharMap1Layer: TLayer = 
      ( TileSetID: 'MainChar';
        TileW: 64; 
        TileH: 96;
        MapW: 8; 
        MapH: 4;
        TileMapData: @MainCharMap1MapData;
        BoundMapData: @MainCharMap1BoundMapData;
      );


  { tile sequences }

  const
    MainCharSequences: array[0..0] of IntArrayPtr =
    (
      Nil
    );

  const
    MainCharSeqLength: array[0..0] of Integer =
    (
      -1
    );


  procedure CandleMap1MapData;
  procedure CandleMap1BoundMapData;

  const
    CandleMap1Layer: TLayer = 
      ( TileSetID: 'Candle';
        TileW: 16; 
        TileH: 32;
        MapW: 4; 
        MapH: 4;
        TileMapData: @CandleMap1MapData;
        BoundMapData: @CandleMap1BoundMapData;
      );


  { tile sequences }

  const
    CandleSequences: array[0..0] of IntArrayPtr =
    (
      Nil
    );

  const
    CandleSeqLength: array[0..0] of Integer =
    (
      -1
    );


  procedure RainMap1MapData;
  procedure RainMap1BoundMapData;

  const
    RainMap1Layer: TLayer = 
      ( TileSetID: 'Rain';
        TileW: 10; 
        TileH: 16;
        MapW: 3; 
        MapH: 3;
        TileMapData: @RainMap1MapData;
        BoundMapData: @RainMap1BoundMapData;
      );


  { tile sequences }

  const
    RainSequences: array[0..0] of IntArrayPtr =
    (
      Nil
    );

  const
    RainSeqLength: array[0..0] of Integer =
    (
      -1
    );

 

implementation

  procedure MainCharMap1MapData; assembler;
  asm
    dd 1,2,3,4,5,6,7,0
    dd 0,0,0,0,0,0,0,0
    dd 8,9,10,11,12,13,14,0
    dd 0,0,0,0,0,0,0,0 
  end;

  procedure MainCharMap1BoundMapData; assembler;
  asm
    dd 0,0,0,0,0,0,0,0
    dd 0,0,0,0,0,0,0,0
    dd 0,0,0,0,0,0,0,0
    dd 0,0,0,0,0,0,0,0 
  end;


  procedure CandleMap1MapData; assembler;
  asm
    dd 0,0,0,0
    dd 0,1,2,0
    dd 0,3,4,0
    dd 0,0,0,0 
  end;

  procedure CandleMap1BoundMapData; assembler;
  asm
    dd 0,0,0,0
    dd 0,0,0,0
    dd 0,0,0,0
    dd 0,0,0,0 
  end;


  procedure RainMap1MapData; assembler;
  asm
    dd 1,2,3
    dd 4,5,6
    dd 7,8,9 
  end;

  procedure RainMap1BoundMapData; assembler;
  asm
    dd 0,0,0
    dd 0,0,0
    dd 0,0,0 
  end;



end.
